/********************************************************************************************************
 * @file     app_config.h 
 *
 * @brief    This is the source file for TLSR8278
 *
 * @author	 Driver Group
 * @date     May 8, 2018
 *
 * @par      Copyright (c) 2018, Telink Semiconductor (Shanghai) Co., Ltd.
 *           All rights reserved.
 *
 *           The information contained herein is confidential property of Telink
 *           Semiconductor (Shanghai) Co., Ltd. and is available under the terms
 *           of Commercial License Agreement between Telink Semiconductor (Shanghai)
 *           Co., Ltd. and the licensee or the terms described here-in. This heading
 *           MUST NOT be removed from this file.
 *
 *           Licensees are granted free, non-transferable use of the information in this
 *           file under Mutual Non-Disclosure Agreement. NO WARRENTY of ANY KIND is provided.
 * @par      History:
 * 			 1.initial release(DEC. 26 2018)
 *
 * @version  A001
 *
 *******************************************************************************************************/

#pragma once
#include "drivers.h"
#include "application/usbstd/usb.h"

/* Enable C linkage for C++ Compilers: */
#if defined(__cplusplus)
extern "C" {
#endif


#define	 USB_MOUSE          1
#define	 USB_KEYBOARD		2
#define	 USB_MICROPHONE		3
#define	 USB_SPEAKER		4
#define	 USB_CDC	        5

#define	 USB_DEMO_TYPE		USB_MOUSE





/* Define LED pin :C1T139A30_V1.0 */
#define RED_LED                 	GPIO_PD0
#define YELLOW_LED     				GPIO_PD3
#define GREEN_LED    		    	GPIO_PD4
#define BLUE_LED                	GPIO_PD5
#define ON            				1
#define OFF           				0


/*config for mic */

#define AUDIO_AMIC_TO_USB		1
#define AUDIO_DMIC_TO_USB		2
#define AUDIO_CODEC_TO_USB		3

#define AUDIO_MIC_MODE				AUDIO_AMIC_TO_USB

/*config for spk */
#define AUDIO_USB_TO_SDM			1

#define  AUDIO_SPK_MODE				1



/* Define system clock */
#define CLOCK_SYS_CLOCK_HZ  	16000000					///< define system clock

#if(CLOCK_SYS_CLOCK_HZ==12000000)
	#define SYS_CLK  	SYS_CLK_12M_Crystal
#elif (CLOCK_SYS_CLOCK_HZ==16000000)
	#define SYS_CLK  	SYS_CLK_16M_Crystal
#elif (CLOCK_SYS_CLOCK_HZ==24000000)
	#define SYS_CLK  	SYS_CLK_24M_Crystal
#elif (CLOCK_SYS_CLOCK_HZ==32000000)
	#define SYS_CLK  	SYS_CLK_32M_Crystal
#elif (CLOCK_SYS_CLOCK_HZ==48000000)
	#define SYS_CLK  	SYS_CLK_48M_Crystal
#endif

/* List tick per second/millisecond/microsecond */
enum{
	CLOCK_SYS_CLOCK_1S = CLOCK_SYS_CLOCK_HZ,				///< system tick per 1 second
	CLOCK_SYS_CLOCK_1MS = (CLOCK_SYS_CLOCK_1S / 1000),		///< system tick per 1 millisecond
	CLOCK_SYS_CLOCK_1US = (CLOCK_SYS_CLOCK_1S / 1000000),   ///< system tick per 1 microsecond
};





/* Disable C linkage for C++ Compilers: */
#if defined(__cplusplus)
}
#endif
