/********************************************************************************************************
 * @file     aaa_24g_app.c
 *
 * @brief    for TLSR chips
 *
 * @author	 telink
 * @date     Sep. 30, 2010
 *
 * @par      Copyright (c) 2010, Telink Semiconductor (Shanghai) Co., Ltd.
 *           All rights reserved.
 *           
 *			 The information contained herein is confidential and proprietary property of Telink 
 * 		     Semiconductor (Shanghai) Co., Ltd. and is available under the terms 
 *			 of Commercial License Agreement between Telink Semiconductor (Shanghai) 
 *			 Co., Ltd. and the licensee in separate contract or the terms described here-in. 
 *           This heading MUST NOT be removed from this file.
 *
 * 			 Licensees are granted free, non-transferable use of the information in this 
 *			 file under Mutual Non-Disclosure Agreement. NO WARRENTY of ANY KIND is provided. 
 *           
 *******************************************************************************************************/

#include "AAA_public_config.h"

#define PACKECT_TWO_ENABLE  1




extern void mouse_task_when_rf();


typedef enum{
	STATE_POWERON = 0,        
	STATE_SYNCING,
	STATE_PAIRING ,
	STATE_NORMAL,
	//STATE_SUSPEND,
	//STATE_DEEPSLEEP,
	//STATE_EMI,

}MOUSE_MODE;

#define SERACH_DONGLE_TIME   1250  //UINT 8mS
#define LONG_SUSPEND_TIME    100 //UINT 1MS

#define DEEP_RETION_TIME 4//UINT 1S

#define BASE_SUSPEND_TIME    8  //UINT 1MS
//#define SHORT_SUSPEND_TIME   8 //UINT 1MS


#define PARING_POWER_ON_CNT     64


#define EMPTY_PACKET_AAA     80

#if(!MOUSE_PIPE1_DATA_WITH_DID)

_attribute_data_retention_user u8 pipe1_send_id_flg ;
#endif

u8 pub_key[16]={
	0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x10};

_attribute_data_retention_user u8 private_key[16]={
	0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x10};

_attribute_data_retention_user u8 data_num=0;
_attribute_data_retention_user mouse_data_t last_ms_data;

_attribute_data_retention_user u8 device_paired_flag=0;
_attribute_data_retention_user u8 device_status=0;
_attribute_data_retention_user u32 dongle_id;

//_attribute_data_retention_user u8 mouse_send_need_f=1;

_attribute_data_retention_user u16 no_ack=0;
_attribute_data_retention_user u8 keyboard_send_need_f=0;

_attribute_data_retention_user u16 power_on_cnt=0;

ENC_RF_DATA device_rf_src_dat;



_attribute_data_retention_user rf_packet_pairing_t	pkt_pairing = {
		sizeof (rf_packet_pairing_t) - 4,	// dma_len

		sizeof (rf_packet_pairing_t) - 5,	// rf_len
		RF_PROTO_BYTE,						// proto

		PKT_FLOW_DIR,	                    // flow
		FRAME_TYPE_KEYBOARD,					// type

//		PIPE0_CODE,			// gid0

		0,					// rssi
		0,					// per
		0,					// seq_no
		0,					// reserved
		0x0c0c0c0c			// device id
};
#if 0
_attribute_data_retention_user rf_packet_mouse_t	pkt_mouse = {
		sizeof (rf_packet_mouse_t) - 4,	// dma_len

		sizeof (rf_packet_mouse_t) - 5,	// rf_len,	28-5 = 0x17
		RF_PROTO_BYTE,					// proto,	0x51
		PKT_FLOW_DIR,					// flow,	0x80
		FRAME_TYPE_MOUSE,				// type,	0x01

//		U32_MAX,			// gid0

		0,					// rssi
		0,					// per
		0,					// seq_no
		1,					// number of frame
};
#endif
_attribute_data_retention_user rf_packet_keyboard_t pkt_kb={
		sizeof (rf_packet_keyboard_t) - 4,	//0x10=20-4,dma_len

		sizeof (rf_packet_keyboard_t) - 5,	//0x0f=20-5,rf_len
		RF_PROTO_BYTE,						// 0x51, proto
		PKT_FLOW_DIR,						// 0x80, kb data flow
		FRAME_TYPE_KEYBOARD,				// 0x02, type

//		U32_MAX,			// gid0

		0,					// rssi
		0,					// per
		0,					// seq_no
		1,					// pno
};


_attribute_data_retention_user u32 tick_loop=0;
_attribute_data_retention_user u32 wakeup_next_tick=0;
_attribute_data_retention_user u16 wake_timer=BASE_SUSPEND_TIME;
_attribute_data_retention_user u8 count=0;
_attribute_data_retention_user u8 pair_success_flag=0;
_attribute_data_retention_user u8* use_rf_pkt = (u8*)&pkt_pairing;


_attribute_ram_code_  void kb_led_out_aaa(u8 status)
{
	
#if HAS_NUM_LED_AAA
	led_num_set((status&0x01)?LED_ON_AAA:LED_OFF_AAA);
#endif
   
	
#if HAS_CAPS_LED_AAA
	led_caps_set((status&0x02)?LED_ON_AAA:LED_OFF_AAA);
#endif
	
#if HAS_SCROLL_LED_AAA
	led_scroll_set((status&0x04)?LED_ON_AAA:LED_OFF_AAA);
#endif
}

_attribute_ram_code_ u8  rf_rx_process(rf_packet_ack_pairing_t * p_pkt)
{

	//rf_packet_ack_pairing_t *p_pkt = (rf_packet_ack_pairing_t *) (p);


	if (p_pkt->proto == RF_PROTO_BYTE) {
		#if ((AES_METHOD==0)||(AES_METHOD==1))
        if ((p_pkt->type == FRAME_TYPE_ACK) && (p_pkt->did == pkt_pairing.did))
#elif ((AES_METHOD==2))
        if ((p_pkt->type == FRAME_TYPE_ACK) && (memcmp(&p_pkt->did, &pkt_pairing.did, 16)==0))
#endif
        {
		    dongle_id=p_pkt->gid1;
		    pair_success_flag=1;
			return 1;
		}
		////////// end of PIPE1 /////////////////////////////////////
		///////////// PIPE1: ACK /////////////////////////////
		else if (p_pkt->type == FRAME_TYPE_ACK_MOUSE) {
#if(!MOUSE_PIPE1_DATA_WITH_DID)
			pipe1_send_id_flg = 0;
#endif
            
			return 1;
		}
		else if (p_pkt->type == FRAME_TYPE_ACK_KEYBOARD) {
#if(!MOUSE_PIPE1_DATA_WITH_DID)
			pipe1_send_id_flg = 0;
#endif	
			rf_packet_ack_keyboard_t* kb_ack=((rf_packet_ack_keyboard_t*)p_pkt);
            kb_led_status=kb_ack->status;
            kb_led_out_aaa(kb_led_status);	
			return 1;
		}
#if(!MOUSE_PIPE1_DATA_WITH_DID)
		else if(p_pkt->type == FRAME_AUTO_ACK_MOUSE_ASK_ID){ //fix auto bug
			pipe1_send_id_flg = 1;
			
			return 1;
		}
#endif
#if(!MOUSE_PIPE1_DATA_WITH_DID)
				else if(p_pkt->type == FRAME_AUTO_ACK_KB_ASK_ID){
					pipe1_send_id_flg = 1;//fix auto bug
					rf_packet_ack_keyboard_t* kb_ack=((rf_packet_ack_keyboard_t*)p_pkt);

                     kb_led_status=kb_ack->status;
            		kb_led_out_aaa(kb_led_status);
					return 1;
				}
#endif

		////////// end of PIPE1 /////////////////////////////////////
	}
	return 0;
}
u8 d24_notify_data_proc_aaa()
{
	 u8 ret=0;
	// u16 att_handle=0;
	 if (tx_fifo_aaa.wptr!=tx_fifo_aaa.rptr)
	 {
		//wake_timer=BASE_SUSPEND_TIME;
		 TX_PACKET_AAA *p = (TX_PACKET_AAA*)tx_fifo_aaa.fifo[tx_fifo_aaa.rptr& (TX_FIFO_NUM_AAA-1)];
        if(combination_flag)
         {
 			memset(p->buf,0,p->len);
         }
		  else if(p->type==HAS_CONSUMER_REPORT)
		 {
            
		#if CONSUMER_REPORT_BYTE_AAA
			keyboard_send_need_f=1;
		
			device_rf_src_dat.device_buf[0]=1;
			device_rf_src_dat.device_buf[1]=0;
			device_rf_src_dat.device_buf[2]=p->buf[0];
			device_rf_src_dat.device_buf[3]=0;
			device_rf_src_dat.device_buf[4]=0;
			device_rf_src_dat.device_buf[5]=0;
			device_rf_src_dat.device_buf[6]=0;
			device_rf_src_dat.device_buf[7]=0;
		#else
			keyboard_send_need_f=1;
			device_rf_src_dat.device_buf[0]=1;
			u32 temp=p->buf[0]+(p->buf[1]<<8)+(p->buf[2]<<16)+(p->buf[3]<<24);
			device_rf_src_dat.device_buf[1]=0;
			device_rf_src_dat.device_buf[2]=0;

			for(u8 i=0;i<32;i++)
			{
				if(temp&(1<<i))
				{
					device_rf_src_dat.device_buf[2]=C_INDEX_START+i;
					break;
				}
			}
			
		#endif
			
		   	pkt_kb.pno=1;
		 }
		 else if(p->type==HAS_KEYBOARD_REPORT)
		 {
		 	
		 	keyboard_send_need_f=1;
			u8 cnt=0;
			for(u8 i=2;i<8;i++)
			{
				   if(p->buf[i]==0)
				   {
			   	  break;
				   }
			   cnt++;
			}
          	device_rf_src_dat.device_buf[0]=cnt;
		   	device_rf_src_dat.device_buf[1]=p->buf[0];
		   	memcpy(&device_rf_src_dat.device_buf[2],&p->buf[2],6);
		 }
		 else if(p->type==HAS_SYSYTEM_REPORT)
		 {
		 #if 1
           keyboard_send_need_f=1;
		 	
           device_rf_src_dat.device_buf[0]=1;
		   device_rf_src_dat.device_buf[1]=0;
		  device_rf_src_dat.device_buf[2]=p->buf[0];
		   device_rf_src_dat.device_buf[3]=0;
		   device_rf_src_dat.device_buf[4]=0;
		   device_rf_src_dat.device_buf[5]=0;
		   device_rf_src_dat.device_buf[6]=0;
		   device_rf_src_dat.device_buf[7]=0;
		   
		   #endif
		 }
		 else
		 {
		 	tx_fifo_aaa.rptr++;
		 }
		 
	 }
 
 	return ret;
}
#if TEST_LOST_RATE
u16 tx_pair_cnt=0;
u16 tx_normal_cnt=0;

extern  volatile unsigned int  rf_rx_cnt;	 
extern  volatile unsigned int  rf_rx_timeout_cnt;
extern  volatile unsigned int  user_rx_timeout_cnt;
extern  volatile unsigned int  user_rx_right_data_cnt;
 

#endif
void adv_pair_proc()
{
	
	
 #if (TEST_LOST_RATE==0)
 	if(user_cfg.rf_vid!= U16_MAX)
  	{
    	set_pair_access_code(rf_access_code_16to32(user_cfg.rf_vid));
	}
    else{
    	//pipe0_id = 0xe7ba;
    	set_pair_access_code (0x39517695);
    }
#else
	set_pair_access_code(rf_access_code_16to32(0x3333));
#endif
	if(device_status==STATE_PAIRING)
	{
		rf_set_power_level_index (user_cfg.paring_tx_power);
		pkt_pairing.flow=PKT_FLOW_PARING;
	}
	
	wake_timer=BASE_SUSPEND_TIME;

    //pkt_pairing.type=FRAME_TYPE_KEYBOARD;
	pkt_pairing.seq_no++;
    pair_success_flag=0;
	clear_fifo();

	if(device_send_packet((u8 *)&pkt_pairing,3,700)&&pair_success_flag)
	{
		#if 1
		no_ack=0;
		
		device_status=STATE_SYNCING;
		
		 device_paired_flag=1;
		
	#if TEST_LOST_RATE
		tx_normal_cnt=0;
		rf_rx_cnt=0;
		rf_rx_timeout_cnt=0;
		user_rx_right_data_cnt=0;
		user_rx_timeout_cnt=0;
	#endif
		#if ((AES_METHOD==0)||(AES_METHOD==1))
        if (flash_dev_info.dongle_id != dongle_id)
	#endif
        {
            flash_dev_info.dongle_id = dongle_id;
			#if (AES_METHOD==2)
            memcpy((u8*)&flash_dev_info.key[0], (u8*)&private_key[4], 12);
			#endif

            save_dev_info_flash();
        }
		reset_idle_status();
		clear_pair_flag();
		#endif

	}
	else
	{
		no_ack++;
		
	#if D24G_ADV_ENTER_DEEPSLEEP_AFTER_TIME_OUT_ENABLE_AAA
         if((idle_count >= D24G_ADV_TIMER_OUT))
		{

			enter_deep_aaa();
		}
	
	#endif
	}
}
void d24_start_pair()
{
	set_pair_flag();
	user_reboot(CLEAR_FLAG_ANA_AAA);
}


void d24_check_pair_process()
{
	 static u8 timer_out_flag=0;
	 static u32 tick;
 
	 if((pair_flag==0)&&key_buf_aaa.special_key_press_f==(T_W_PRESS_AAA|T_ESC_PRESS_AAA))
	 {
        combination_flag=1;
		if((timer_out_flag==0)&&clock_time_exceed(tick,3000000))
	 	{
			d24_start_pair();
			timer_out_flag=1;
	 	}
	 }
	 else
	 {
	 	timer_out_flag=0;
		tick=clock_time();
	 }
}

#if EMI_TEST_FUN_ENABLE_AAA
_attribute_data_retention_user  u8 mode=0;
_attribute_data_retention_user	u8 channel=0;

_attribute_data_retention_user	u8 run_flag=0;


enum {
	EMI_cmd_chn_l  = 0,
	EMI_cmd_chn_m  = 1,
	EMI_cmd_chn_h  = 2,
	//host_cmd_paring = BIT(8),
	EMI_cmd_carrier= 0,
	EMI_cmd_cd		= 1,
	EMI_cmd_rx		= 2,
	EMI_cmd_tx		= 3,
};

void emi_cd_push_fifo()
{
	if(enter_emi_flag&&(mode==EMI_cmd_cd))
	{
	   rf_continue_mode_run();
	}
}
u8 emi_has_change()
{
	static u32 tick;
	u8 has_new_event=0;

	if(clock_time_exceed(tick,10000))
	{
		tick=clock_time();
		
		//has_new_event=scan(0);  
		has_new_event=emi_key_scan();
		
		if(has_new_event)
		{
			if(key_buf_aaa.keycode[0]==KB_F1)
		    {
				channel=EMI_cmd_chn_l % 0x03;
				mode=EMI_cmd_carrier % 0x04;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F2)
		    {
				channel=EMI_cmd_chn_l % 0x03;
				mode=EMI_cmd_cd % 0x04;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F3)
		    {
				channel=EMI_cmd_chn_l % 0x03;
				mode=EMI_cmd_rx % 0x04;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F4)
		    {
				channel=EMI_cmd_chn_l % 0x03;
				mode=EMI_cmd_tx % 0x04;
				run_flag=1;	
			}
			
			else if(key_buf_aaa.keycode[0]==KB_F5)
		    {
				channel=EMI_cmd_chn_m % 0x03;
				mode=EMI_cmd_carrier % 0x04;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F6)
		    {
				channel=EMI_cmd_chn_m % 0x03;
				mode=EMI_cmd_cd % 0x04;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F7)
		    {
				channel=EMI_cmd_chn_m % 0x03;
				mode=EMI_cmd_rx % 0x04;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F8)
		    {
				channel=EMI_cmd_chn_m % 0x03;
				mode=EMI_cmd_tx % 0x04;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F9)
		    {
				channel=EMI_cmd_chn_h % 0x03;
				mode=EMI_cmd_carrier % 0x04;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F10)
		    {
				channel=EMI_cmd_chn_h % 0x03;
				mode=EMI_cmd_cd % 0x04;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F11)
		    {
				channel=EMI_cmd_chn_h % 0x03;
				mode=EMI_cmd_rx % 0x04;
				run_flag=1;	
			}
			else if(key_buf_aaa.keycode[0]==KB_F12)
		    {
				channel=EMI_cmd_chn_h % 0x03;
				mode=EMI_cmd_tx % 0x04;
				run_flag=1;	
			}
			
			
		}

	}

	return run_flag;
}

void emi_init()
{
	//unsigned char chnidx=0;
	write_reg32(0x408,0x29417671 );//access code  0xf8118ac9
	write_reg8(0x80013c,0x10); // print buffer size set

	//write_reg8(0x840005,tx_cnt);//run
	//write_reg8(0x840006,run);//run
	//write_reg8(0x840007,cmd_now);//cmd
	//write_reg8(0x840008,power_level);//power
	//write_reg8(0x840009,chn);//chn
	//write_reg8(0x84000a,mode);//mode
	//write_reg8(0x840004,0);
	//write_reg32(0x84000c,0);
	//shutdown_gpio();//for pm
	WriteAnalogReg(0x33,0xff);

	//flash_read_page(0x77000,1,&chnidx);
	//if(chnidx!=0xff)
	//{
		//chnidx&=0x3f;
		//WriteAnalogReg(0x8a,(ReadAnalogReg(0x8a)&0xc0)|chnidx);//close internal cap
	//}
//	WriteAnalogReg(0x8a,ReadAnalogReg(0x8a)|0x80);//close internal cap
	//rf_set_power_level_index(user_cfg.emi_tx_power);
}

void emicarrieronly(RF_ModeTypeDef rf_mode, RF_PowerTypeDef pwr, signed char rf_chn)
{
    rf_emi_single_tone(pwr, rf_chn);
    while (!emi_has_change());

    rf_emi_stop();
}

void emi_carrier_data(RF_ModeTypeDef rf_mode, RF_PowerTypeDef pwr, signed char rf_chn,u8 data_type)
{
    rf_emi_tx_continue_setup(rf_mode, pwr, rf_chn, data_type);
	
    while (!emi_has_change())
    {
    	
        rf_continue_mode_run();
    }

    rf_emi_stop();
}


void emi_tx_mode(RF_ModeTypeDef rf_mode, RF_PowerTypeDef pwr, signed char rf_chn,u8 data_type)
{
    //unsigned int tx_num=0;
    rf_emi_tx_burst_setup(rf_mode, pwr, rf_chn, data_type);
    while (!emi_has_change())
    {
        rf_emi_tx_burst_loop(rf_mode, data_type);
#if 0
        //if(tx_cnt)
        {
            tx_num++;
            if (tx_num >= 1000)
            {
                while (!emi_has_change());
                break;
            }

        }
#endif
    }

    rf_emi_stop();
}

void emirx(RF_ModeTypeDef rf_mode, RF_PowerTypeDef pwr, signed char rf_chn)
{
    rf_emi_rx(rf_mode, rf_chn);
    //write_reg8(0x840004,0);
    //write_reg32(0x84000c,0);
    while (!emi_has_change())
    {
        rf_emi_rx_loop();
        //if(rf_emi_get_rxpkt_cnt()!=read_reg32(0x84000c))
        {
            //write_reg8(0x840004,rf_emi_get_rssi_avg());
            //write_reg32(0x84000c,rf_emi_get_rxpkt_cnt());
        }
    }
    rf_emi_stop();
}



void emi_serviceloop(void)
{
	
	u8 tbl_chn[3]={05,30,70};
	emi_init();
	run_flag=1;
	irq_disable();
	while(1)
	{
		if(run_flag)
		{
			run_flag=0;
			
			#if BLT_APP_LED_ENABLE
			for(u8 i=0; i<(mode+1);i++)
			{
				sleep_us(250000*(channel+1));
				gpio_write(PIN_24G_LED,LED_OFF_AAA);
				sleep_us(250000*(channel+1));
				gpio_write(PIN_24G_LED,LED_ON_AAA);
			}
			#endif
			//mode=1;
			//user_cfg.emi_tx_power=RF_POWER_P10p46dBm;
			if(mode==0)//carri
			{
				emicarrieronly(RF_MODE_BLE_1M,user_cfg.emi_tx_power,tbl_chn[channel]);
			}
			else if(mode==1)//cd
			{
				emi_carrier_data(RF_MODE_BLE_1M,user_cfg.emi_tx_power,tbl_chn[channel],0);
			}
			else if(mode==2)//rx
			{
				emirx(RF_MODE_BLE_1M,user_cfg.emi_tx_power,tbl_chn[channel]);
			}
			else if(mode==3)//tx
			{
				emi_tx_mode(RF_MODE_BLE_1M,user_cfg.emi_tx_power,tbl_chn[channel],0);
			}
			
		}
		
		
		
	}
}


void emi_key_check_aaa()
{
	if(power_tick&&(!clock_time_exceed(power_tick,200000)))
	{
	 	if((key_buf_aaa.keycode[0]==KB_E)&&(key_buf_aaa.cnt==1))
		{			 
			power_tick = 0;

			enter_emi_flag=1;
			emi_serviceloop(); 
		} 
	}
	else
	{
		power_tick=0;
	}

}

#endif
void fix_auto_pair_dongle()
{
	
#if(!MOUSE_PIPE1_DATA_WITH_DID)
    	//fix auto paring bug, if dongle ACK ask for  id,send it in on pipe1
      
		if(pipe1_send_id_flg)
		{
			#if 1
			keyboard_send_need_f= 1;

			*(u32 *) (&pkt_kb.data[4]) = pkt_pairing.did;  //did in last 4 byte
			
			  
#else
			keyboard_send_need_f= 1;
			u8 buf[8]={0,0,0,0,0,0,0,0};
			*(u32 *) (&buf[4]) = pkt_pairing.did;
			push_data_fifo_aaa(buf,HAS_KEYBOARD_REPORT,BUF_SIZE_KEYBOARD_AAA);
#endif
			pkt_kb.type = FRAME_TYPE_KB_SEND_ID;
			
		}
		else
		{
			 pkt_kb.type = FRAME_TYPE_KEYBOARD;
		}
#endif
}


void aes_user_encryption(u8 *key, u8 *plaintext, u8 *encrypted_data)
{
	
#if 1	//ecb	
	u8 rplaintext[16],rkey[16];
	swapX(plaintext, rplaintext, 16);
	swapX(key, rkey, 16);
	aes_ll_encryption(rkey, rplaintext, encrypted_data);
#else
	u8 rplaintext[16];
	swapX(plaintext, rplaintext, 16);
	aes_ll_encryption(key, rplaintext, encrypted_data);
#endif
}


void aes_user_decryption(u8 *key, u8 *encrypted_data, u8 *decrypted_data)
{
	
#if 1//ecb
	u8 rencrypted_data[16], rkey[16];	
	swapX(key, rkey, 16);
	swapX(encrypted_data, rencrypted_data, 16);
	aes_ll_decryption(rkey, rencrypted_data, decrypted_data);
#else
	u8 rencrypted_data[16];	
	swapX(encrypted_data, rencrypted_data, 16);
	aes_ll_decryption(key, rencrypted_data, decrypted_data);
#endif
}

void d24g_show_mode()
{
    if ((deep_flag == POWER_ON_ANA_AAA) || (deep_flag == MODE_CHANGE_REBOOT_ANA_AAA))
    {
        if (deep_flag == MODE_CHANGE_REBOOT_ANA_AAA)
        {
            write_deep_ana0(CLEAR_FLAG_ANA_AAA);
        }
#if BLT_APP_LED_ENABLE
        led_24g_mode_display();
#endif
    }
}


void d24_user_init()
{

  
 // memcpy(&pkt_pairing.rssi, &output_dev_info.bin_crc, 4);
	/*****************   set up did(device id)    ********************/
 //user_cfg.dev_mac=0xabcdef;

 device_rf_src_dat.device_id = (user_cfg.dev_mac&(0x00ffffff))|(FRAME_TYPE_KEYBOARD<<24);

    

#if MOUSE_PIPE1_DATA_WITH_DID
	pkt_kb.did=device_rf_src_dat.device_id;
#endif 
   dongle_id = flash_dev_info.dongle_id ;
 	
	memcpy((u8*)&private_key[0],(u8*)&device_rf_src_dat.device_id ,4);
 	
#if  ENTER_PAIR_WHEN_NEVER_PAIRED_ENABLE
		if ((dongle_id== U32_MAX) || (dongle_id== 0))
		{
			set_pair_flag();
		}
		else
		{
			device_paired_flag=1;
		}
#endif
	 if (pair_flag)
	 {
	 	device_status = STATE_PAIRING;
		#if((AES_METHOD==1)||(AES_METHOD==0))
		pkt_pairing.did=device_rf_src_dat.device_id;
	#elif (AES_METHOD==2)
		generateRandomNum(12, &private_key[4]);
		aes_user_encryption(pub_key,private_key,(u8*)&pkt_pairing.did);
	#endif
	 }
	 else
	 {
		memcpy((u8*)&private_key[4], (u8*)&flash_dev_info.key[0], 12);
		
		if(deep_flag!=DEEP_SLEEP_ANA_AAA)
		{
			device_status = STATE_SYNCING;
		}
		else
		{
			device_status = STATE_NORMAL;
		}
		
    }
     keyboard_send_need_f=1;


#if (BATT_CHECK_ENABLE)  //battery check must do before OTA relative operation
		user_batt_check_init();
#endif


   
  
	wakeup_next_tick=clock_time();
	
	reset_idle_status();
	

}

u8 test_key[16] =
{
	0x05, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F, 0x10
};

u8 d24_keyboard_sendPacket()
{
	u8 ret=0;

#if (AES_METHOD==0)
	 memcpy((u8 *)&pkt_kb.dat.device_id, &device_rf_src_dat.device_buf[0], 8);
#elif (AES_METHOD==1)
    pkt_kb.pno=0x81;
	memcpy((u8 *)&pkt_kb.dat.device_id, &device_rf_src_dat.device_buf[0], 8);
     generateRandomNum(4, &device_rf_src_dat.device_buf[8]);
       aes_user_encryption(pub_key, &device_rf_src_dat.device_buf[0], (u8 *)&pkt_kb.dat.device_id);
   
			
#elif (AES_METHOD==2)
	generateRandomNum(4, &device_rf_src_dat.rand_dat[0]);
	u8 *p_src = (u8 *)&device_rf_src_dat.device_id;
	u8 *p_enc = (u8 *)&pkt_kb.dat.device_id;
	aes_user_encryption(private_key, &p_src[0], &p_enc[0]); 
    
#endif
	set_data_access_code(flash_dev_info.dongle_id);
	rf_set_power_level_index (user_cfg.tx_power);

	pkt_kb.seq_no++;
	 device_rf_src_dat.seq_no++;
	if( device_send_packet((u8*)&pkt_kb,5, 650) )
	{
		if (tx_fifo_aaa.wptr!=tx_fifo_aaa.rptr)
		{
			tx_fifo_aaa.rptr++;
			
		}
		ret=1;
	}
	else
	{
		pkt_kb.per++;
	}
	return ret;
}

void ui_loop_24g()
{
	u8 is_new_event=0;
		
#if (BATT_CHECK_ENABLE)
	
	user_batt_check_proc();
    
#endif

	

	#if DO_TASK_WHEN_RF_IN_24G_MODE_ENALBE
		p_task_when_rf = mouse_task_when_rf;
	#else
		mouse_task_when_rf();
   
	#endif
	
     is_new_event=get_data_report_aaa();	
	d24_check_pair_process();
	 loop_cnt++;
	if(is_new_event)
	{
		reset_idle_status();
		//wake_timer=BASE_SUSPEND_TIME;
       
	}
     idle_status_poll();
	 
	if((device_status == STATE_NORMAL)||(device_status == STATE_SYNCING))
	{		
		d24_notify_data_proc_aaa();
				
		#if PM_DEEPSLEEP_RETENTION_ENABLE
		else if(idle_count<=DEEP_RETION_TIME)
		{
			wake_timer=SHORT_SUSPEND_TIME;
		}
		#endif
        
		
		fix_auto_pair_dongle();
		u8 has_btn_press=0;

		//if(device_rf_src_dat.device_buf[0]||device_rf_src_dat.device_buf[1]||(loop_cnt<EMPTY_PACKET_AAA))
		if(device_rf_src_dat.device_buf[0]||device_rf_src_dat.device_buf[1])	//EMPTY_PACKET_AAA
		{
			//keyboard_send_need_f=1;
			has_btn_press=1;
		}
		
		if(keyboard_send_need_f||has_btn_press)
		{
			//sleep_us(2000);
			if(d24_keyboard_sendPacket())
			{
				keyboard_send_need_f=0;
				device_status=STATE_NORMAL;
				if(!(device_rf_src_dat.device_buf[1]||device_rf_src_dat.device_buf[2]))
				{
					device_rf_src_dat.device_buf[0]=0;
				}
				#if BLT_APP_LED_ENABLE
				if(device_status==STATE_SYNCING)
				{
					//led_24g_ConnectedStatus();
				}
				#endif
				no_ack=0;
			}
			else
			{
				no_ack++;
				if (no_ack>125)
				{
					device_status=STATE_SYNCING;
				}
				if(no_ack>SERACH_DONGLE_TIME)
				{
					enter_deep_aaa();
				}
		
			}
		
		}
		
		if(DEVICE_LED_BUSY||/*(key_buf_aaa.press_cnt>0)||*/(no_ack>0)||keyboard_send_need_f||(loop_cnt<EMPTY_PACKET_AAA))
	 	{
	 		wake_timer=BASE_SUSPEND_TIME;
	 	}
	     else
	     {
	 		wake_timer=LONG_SUSPEND_TIME;
	     }
		
  #if D24G_CONNECT_ENTER_DEEPSLEEP_AFTER_TIME_OUT_ENABLE_AAA

		if((idle_count>=D24G_CONNECT_TIME_OUT))
		{
			enter_deep_aaa();
		}
	#endif
	}
	else if(device_status == STATE_PAIRING)
	{	
		adv_pair_proc();		
	} 
 #if DO_TASK_WHEN_RF_IN_24G_MODE_ENALBE



     if (p_task_when_rf != NULL) {
       (*p_task_when_rf) ();
    }
 #endif
     //for keyboard it is not called it mouse be called
	//device_channel = get_next_channel_with_mask (ll_chn_mask, device_channel);

    device_led_process();
	
	
}


void d24_main_loop()
{
#if 0
#if 0
   static u8 flag=0;
	if((flag==0)&&clock_time_exceed(wakeup_next_tick,8000))
	{
		
		
		d24_loop_count++;
		if(d24_loop_count==1000)
		{
			flag=1;
		}
		wakeup_next_tick=clock_time(); 
		ui_loop_24g();
	}
#else
	if(clock_time_exceed(wakeup_next_tick,8000))
	{
		
		wakeup_next_tick=clock_time(); 
		ui_loop_24g();
	}
#endif

#else
#if 1

	

	
	connect_ok=(device_status == STATE_NORMAL)?1:0;
	
	if((connect_ok==0))
	{
	#if BLT_APP_LED_ENABLE
			led_2p4_Adv_poll();
	#endif
	}

	ui_loop_24g();

	
	if(wake_timer==BASE_SUSPEND_TIME)
    {
	
		if(suspend_wake_up_enable)
		{
			for(int i=0;i<TOTAL_ROW;i++)
			{
				if(gpio_read(row_pins[i]))
				{
					cpu_set_gpio_wakeup(row_pins[i], 0, 0); //pad  wakeup deep
				}
				else
				{
					cpu_set_gpio_wakeup(row_pins[i], 1, 0);
				}
			}
		}
		suspend_wake_up_enable=0;
		cpu_sleep_wakeup(SUSPEND_MODE, PM_WAKEUP_TIMER, (wakeup_next_tick+wake_timer*CLOCK_SYS_CLOCK_1MS-1600) );
   
    }
	else
	{
		
		if(suspend_wake_up_enable==0)
		{
			for(int i=0;i<TOTAL_ROW;i++)
			{
				if(gpio_read(row_pins[i]))
				{
					cpu_set_gpio_wakeup(row_pins[i], 0, 1); //pad  wakeup deep
				}
				else
				{
					cpu_set_gpio_wakeup(row_pins[i], 1, 1);
				}
			}
		}
		suspend_wake_up_enable=1;
	#if PM_DEEPSLEEP_RETENTION_ENABLE
        if(wake_timer==LONG_SUSPEND_TIME)
        {
			cpu_sleep_wakeup(DEEPSLEEP_MODE_RET_SRAM_LOW16K, PM_WAKEUP_PAD|PM_WAKEUP_TIMER, (wakeup_next_tick+wake_timer*CLOCK_SYS_CLOCK_1MS-1000) );
        }
		else
	#endif
		{
			cpu_sleep_wakeup(SUSPEND_MODE, PM_WAKEUP_PAD|PM_WAKEUP_TIMER, (wakeup_next_tick+wake_timer*CLOCK_SYS_CLOCK_1MS-1000) );
		}
	}
	#else
		cpu_sleep_wakeup(SUSPEND_MODE, PM_WAKEUP_TIMER, (wakeup_next_tick+8*CLOCK_SYS_CLOCK_1MS) );
	#endif
   wakeup_next_tick=clock_time(); 
  
    #if PM_DEEPSLEEP_RETENTION_ENABLE
   	if((wake_timer!=LONG_SUSPEND_TIME))
	#endif	
   	{
		rf_drv_private_2m_init();
   	}
	 //wake_timer=LONG_SUSPEND_TIME;
   
	
#endif


	
    
	  


}

