/********************************************************************************************************
 * @file     aaa_public.c
 *
 * @brief    for TLSR chips
 *
 * @author	 telink
 * @date     Sep. 30, 2010
 *
 * @par      Copyright (c) 2010, Telink Semiconductor (Shanghai) Co., Ltd.
 *           All rights reserved.
 *
 *			 The information contained herein is confidential and proprietary property of Telink
 * 		     Semiconductor (Shanghai) Co., Ltd. and is available under the terms
 *			 of Commercial License Agreement between Telink Semiconductor (Shanghai)
 *			 Co., Ltd. and the licensee in separate contract or the terms described here-in.
 *           This heading MUST NOT be removed from this file.
 *
 * 			 Licensees are granted free, non-transferable use of the information in this
 *			 file under Mutual Non-Disclosure Agreement. NO WARRENTY of ANY KIND is provided.
 *
 *******************************************************************************************************/

#include "AAA_public_config.h"
#define COMB_BTN_PAIR  (MS_BTN_LEFT|MS_BTN_MIDDLE|MS_BTN_RIGHT)
#if DOUBLE_CLICK_LEFT_FUN_ENABLE

    _attribute_data_retention_user static u32 double_click_left_tick;
    _attribute_data_retention_user static u8 has_double_click_cnt;
    _attribute_data_retention_user u8 has_double_click_left = 0;
    #define DOUBLE_CLICK_LEFT_INTERVAL  40000

#endif
_attribute_data_retention_user  u8 switch_type=TWO_SPEED_SWITCH;
_attribute_data_retention_user  u8 active_disconnect_reason=0;

_attribute_data_retention_user  u32 power_on_tick = 0;
_attribute_data_retention_user  u8 device_name_len = 0;
_attribute_data_retention_user  u8 connect_ok = 0;


_attribute_data_retention_user custom_cfg_t   user_cfg;
_attribute_data_retention_user u8 fun_mode = RF_1M_BLE_MODE;
_attribute_data_retention_user FLASH_DEV_INFO_AAA flash_dev_info;
_attribute_data_retention_user FLASH_DPI_INFO_AAA flash_dpi_info;


_attribute_data_retention_user u8 suspend_wake_up_enable = 1;
_attribute_data_retention_user u8 deep_flag = POWER_ON_ANA_AAA;
_attribute_data_retention_user u8 pair_flag = 0;
_attribute_data_retention_user u8 ana_reg1_aaa = 0;
_attribute_data_retention_user u8 has_been_paired_flag = 0;


_attribute_data_retention_user u8 has_new_report_aaa;
_attribute_data_retention_user u8 has_new_key_event = 0;


_attribute_data_retention_user u8 combination_flag = 0;
_attribute_data_retention_user TX_FIFO_AAA_STRUCT tx_fifo_aaa;


_attribute_data_retention_user u16 btn_value = 0;
_attribute_data_retention_user u16 last_btn_value = 0;
_attribute_data_retention_user u8 mouse_btn_in_sensor;
//u8 last_mosue_btn_in_sensor;
_attribute_data_retention_user mouse_data_t ms_data;
_attribute_data_retention_user mouse_data_t ms_buf;

_attribute_data_retention_user u8 wheel_pre = 0;
_attribute_data_retention_user u8 wheel_status;

void save_dev_info_flash()
{
    dev_info_idx += SAVE_MAX_IN_FLASH;
    flash_write_page(CFG_DEVICE_MODE_ADDR + dev_info_idx, SAVE_MAX_IN_FLASH, (u8 *)&flash_dev_info.dongle_id);
    //sleep_us(50000);
}
#if BUTTON_FUN_ENABLE_AAA

_attribute_data_retention_user  u32 btn_tick = 0;
_attribute_data_retention_user 	u32 btn_pins[BTN_NUM_AAA] = BTN_MATRIX;


void btn_set_wakeup_level_suspend(u8 enable)
{
    for (u8 i = 0; i < BTN_NUM_AAA; i++)
    {
        if (gpio_read(btn_pins[i]))
        {
            cpu_set_gpio_wakeup(btn_pins[i], 0, enable); //low wakeup suspend

        }
        else
        {
            cpu_set_gpio_wakeup(btn_pins[i], 1, enable);
        }
    }

}


void btn_set_wakeup_level_deep()
{
    for (u8 i = 0; i < BTN_NUM_AAA; i++)
    {
        if (gpio_read(btn_pins[i]))
        {
            cpu_set_gpio_wakeup(btn_pins[i], 0, 1); //low wakeup suspend
            //connected_idle_time_count_ykq=0;
        }
        else
        {
            cpu_set_gpio_wakeup(btn_pins[i], 1, 1);
        }
    }

}


static void btn_init_hw()
{
#if 0
    for (u8 i = 0; i < BTN_NUM_AAA; i++)
    {

        gpio_set_input_en(btn_pins[i], 1);
        gpio_set_output_en(btn_pins[i], 0);
        gpio_setup_up_down_resistor(btn_pins[i], PM_PIN_PULLUP_1M);

    }
#endif
    //btn_set_wakeup_level_suspend();
}
void ble_start_pair()
{
	set_pair_flag();
	if(connect_ok)
	{
		active_disconnect_reason=BLE_PAIR_REBOOT_ANA_AAA;
	}
	else
	{
		user_reboot(BLE_PAIR_REBOOT_ANA_AAA);
	}
//telink public
}
void three_speed_switch_pair()
{
	if(fun_mode==RF_1M_BLE_MODE)
	{
		if ((((btn_value&COMB_BTN_PAIR)==COMB_BTN_PAIR)||((btn_value&MS_BTN_PAIR)==MS_BTN_PAIR)) && (clock_time_exceed(btn_tick, 2100000))) 
		{
			ble_start_pair();
		}
	}
	else 
	{
		if ((((btn_value&COMB_BTN_PAIR)==COMB_BTN_PAIR)) && (clock_time_exceed(btn_tick, 2100000))) 
		{
			d24_start_pair();
		}
	}
}
void two_speed_switch_pair()
{
	if(fun_mode==RF_1M_BLE_MODE)
	{
		if ((((btn_value&COMB_BTN_PAIR)==COMB_BTN_PAIR)||((btn_value&MS_BTN_MODE)==MS_BTN_MODE)) && (clock_time_exceed(btn_tick, 2100000))) 
		{
			ble_start_pair();
		}
	}
	else 
	{
		if ((((btn_value&COMB_BTN_PAIR)==COMB_BTN_PAIR)) && (clock_time_exceed(btn_tick, 2100000))) 
		{
			d24_start_pair();
		}
	}
}
void three_switch_mode_change_poll()
{
    _attribute_data_retention_user static u32 tick;
    if (IS_BLE_MODE_AAA)
    {
        flash_dev_info.mode = RF_1M_BLE_MODE;
    }
    else
    {
        flash_dev_info.mode = RF_2M_2P4G_MODE;
    }
    if (fun_mode != flash_dev_info.mode)
    {
        if (clock_time_exceed(tick, 300000))
        {
            user_reboot(MODE_CHANGE_REBOOT_ANA_AAA);
        }
    }
    else
    {
        tick = clock_time();
    }
}
void two_switch_mode_change_poll(u8 event_new)
{
    _attribute_data_retention_user static u8 mode_btn_release_cnt = 0;
    u8 need_change_mode=0;
    if (event_new)
    {
        if ((last_btn_value & MS_BTN_MODE))
        {
			mode_btn_release_cnt++;
		#if ENTER_PAIR_WHEN_NEVER_PAIRED_ENABLE
			if ((pair_flag == 1)&&has_been_paired_flag)
		#else
			if ((pair_flag == 1))
		#endif
			{
				if(mode_btn_release_cnt>=2)
				{
					need_change_mode=1;
				}
            }
			else
			{
				need_change_mode=1;
			}
			if(need_change_mode)
			{
				clear_pair_flag();
				if (fun_mode == RF_1M_BLE_MODE)
                {
                  	if(connect_ok)
					{
						active_disconnect_reason=MODE_CHANGE_REBOOT_ANA_AAA;
					}
					else
					{
						flash_dev_info.mode = RF_2M_2P4G_MODE;
        				save_dev_info_flash();
        				user_reboot(MODE_CHANGE_REBOOT_ANA_AAA);
					}
                }
                else
                {
                	flash_dev_info.mode = RF_1M_BLE_MODE;
                	save_dev_info_flash();
                	user_reboot(MODE_CHANGE_REBOOT_ANA_AAA);
                }
        	}
    	}
    } 
}
void button_process_telink_v21a(u8 event_new)
{
    //attribute_data_retention_user static u8 d24g_power_on_Pair_flag = 0;
    //-----------------cpi ------------------------

    if ((last_btn_value & MS_BTN_CPI) && event_new)
    {
#if SENSOR_FUN_ENABLE_AAA
        if (connect_ok)
        {
            btn_dpi_set();
        }
#endif
    }
    //-----------------pair ------------------------
    if(pair_flag==0)
    {
		if(switch_type==THREE_SPEED_SWITCH)
        {
			 three_speed_switch_pair();
		}
		else
		{
			two_speed_switch_pair();
        }
			
    }
	
    //-----------------mode change ------------------------
	if(switch_type==THREE_SPEED_SWITCH)
    {
		three_switch_mode_change_poll();
            }
            else
     {
		two_switch_mode_change_poll(event_new);
	}
	

}

static inline u8 button_get_status(u32 pin)
    {
    u8 value = 0; //no button press

    if (!gpio_read(pin)) //connect gnd
        {
        value = 1;

                }
                else
                {
        gpio_setup_up_down_resistor(pin, PM_PIN_PULLDOWN_100K);
        gpio_write(pin, 0);
        sleep_us(10);
        if (gpio_read(pin))
            {
            value = 2;
        }
        gpio_write(pin, 1);
        gpio_setup_up_down_resistor(pin, PM_PIN_PULLUP_1M);
    }

    //-----------------muti_device switch ------------------------
    return value;
}
u16 btn_scan()
{
    u16 now_value = 0;
    if (!gpio_read(PIN_BTN_LEFT))
    {
        now_value |= MS_BTN_LEFT;
    }
    if (!gpio_read(PIN_BTN_RIGHT))
    {
        now_value |= MS_BTN_RIGHT;
    }
    if (!gpio_read(PIN_BTN_MIDDLE))
    {
        now_value |= MS_BTN_MIDDLE;
    }
    if (!gpio_read(PIN_BTN_K4))
    {
#if MUTI_DEVICE_SWITCH_DEBUG
        now_value |= MS_BTN_DEVICE_2;
#else
        now_value |= MS_BTN_K4;
#endif
    }
    if (!gpio_read(PIN_BTN_K5))
    {
#if MUTI_DEVICE_SWITCH_DEBUG
        now_value |= MS_BTN_DEVICE_1;
#else
        now_value |= MS_BTN_K5;
#endif
    }

    if (!gpio_read(PIN_BTN_CPI))
    {
        now_value |= MS_BTN_CPI;
        //now_value|=MS_BTN_DOUBLE_LEFT;
    }

    if (!gpio_read(PIN_MODE_SWITCH))
    {
        now_value |= MS_BTN_MODE;
    }
    return  now_value;
}

u8 btn_get_value()
{
    u8 ret = 0;
    _attribute_data_retention_user  static u8 debounce = 0;
    u16 now_value = 0;
    _attribute_data_retention_user static u16 last_value = 0;


    now_value = btn_scan();

    if (last_value != now_value)
    {
        reset_idle_status();
        debounce = 1;
        last_value = now_value;
    }

    if (debounce)
    {
        debounce++;
        if (debounce == 3)
        {
            ret = NEW_KEY_EVENT_AAA;
            ms_data.btn = now_value & 0X1F;
            btn_value = now_value;
            btn_tick = clock_time();
#if DOUBLE_CLICK_LEFT_FUN_ENABLE
            if (btn_value == MS_BTN_DOUBLE_LEFT)
            {
                has_double_click_left = 1;
                double_click_left_tick = 0;
            }
#endif
            debounce = 0;
        }
    }

    button_process_telink_v21a(ret);



    //btn_set_wakeup_level_suspend(1);
    return ret;

}

#endif

#if WHEEL_FUN_ENABLE_AAA


void wheel_set_wakeup_level_suspend(u8 enable)
{
#if 1

    if (gpio_read(PIN_WHEEL_1))
    {
        cpu_set_gpio_wakeup(PIN_WHEEL_1, 0, enable); //low wakeup suspend
        //connected_idle_time_count_ykq=0;
    }
    else
    {
        cpu_set_gpio_wakeup(PIN_WHEEL_1, 1, enable);
    }

    if (gpio_read(PIN_WHEEL_2))
    {
        cpu_set_gpio_wakeup(PIN_WHEEL_2, 0, enable); //low wakeup suspend
        //connected_idle_time_count_ykq=0;
    }
    else
    {
        cpu_set_gpio_wakeup(PIN_WHEEL_2, 1, enable);
    }
#endif
}

void wheel_set_wakeup_level_deep()
{

#if 1
    if (gpio_read(PIN_WHEEL_1))
    {

        cpu_set_gpio_wakeup(PIN_WHEEL_1, 0, 1);
    }
    else
    {
        cpu_set_gpio_wakeup(PIN_WHEEL_1, 1, 1);
    }

    if (gpio_read(PIN_WHEEL_2))
    {
        cpu_set_gpio_wakeup(PIN_WHEEL_2, 0, 1);
    }
    else
    {
        cpu_set_gpio_wakeup(PIN_WHEEL_2, 1, 1);
    }
#endif
}
static void wheel_init_hw()
{
#if 0
    gpio_set_input_en(PIN_WHEEL_1, 1);
    gpio_set_output_en(PIN_WHEEL_1, 0);
    gpio_setup_up_down_resistor(PIN_WHEEL_1, PM_PIN_PULLUP_1M);

    gpio_set_input_en(PIN_WHEEL_2, 1);
    gpio_set_output_en(PIN_WHEEL_2, 0);
    gpio_setup_up_down_resistor(PIN_WHEEL_2, PM_PIN_PULLUP_1M);


#endif


    write_reg8(0xd2, WHEEL_ADDRES_D2); // different gpio different value
    write_reg8(0xd3, WHEEL_ADDRES_D3);


    write_reg8(0xd7, 0x01);  //BIT(0) 0: 1¸ñ        1:  2¸ñ      	BIT(1)  wakeup enable

    write_reg8(0xd1, 0x01);  //filter   00-07     00 is best

	

#if 0
    u8 core_reg65 = read_reg8(0x65);
    core_reg65 |= (BIT(0) | BIT(5));
    write_reg8(0x65, core_reg65);  //wheel clk enable
#else
	reg_rst0 |= FLD_RST0_QDEC;   // for8258  power on 
	reg_rst0 &= (~FLD_RST0_QDEC);
    rc_32k_cal();
    BM_SET(reg_clk_en0, FLD_CLK0_QDEC_EN);
#endif


}
u32 mouse_wheel_prepare_tick(void)
{

    write_reg8(0xd8, 0x01);
    return clock_time();
}

_attribute_ram_code_ s8 mouse_wheel_process(u32 wheel_prepare_tick)
{
    s8 ret = 0;
    while (read_reg8(0xd8) & 0x01)
    {
        if (clock_time_exceed(wheel_prepare_tick, 260))  //4 cylce is enough: 4*1/32k = 1/8 ms
        {
            write_reg8(0xd6, 0x01); //reset  d6[0]
            write_reg8(0xd6, 0x00);
            break;
        }
    }

#if 1//(WHEEL_TWO_STEP_PROC)
    _attribute_data_retention_user static signed char accumulate_wheel_cnt;
    _attribute_data_retention_user static signed char wheel_cnt;
    wheel_cnt = read_reg8(0xd0);

    wheel_cnt += accumulate_wheel_cnt;

    if (wheel_cnt & 1) //Ææ
    {
        accumulate_wheel_cnt = wheel_cnt > 0 ? 1 : -1;
    }
    else  //Å¼
    {
        accumulate_wheel_cnt = 0;
    }
    ret = (wheel_cnt / 2);
#else
    ret = read_reg8(0xd0);
#endif
    return ret;
}
#if PM_DEEPSLEEP_RETENTION_ENABLE
s8 wheel_vaule = 0;
_attribute_ram_code_ u8 wheel_get_value_1()
{
    u8 ret = 0;

    u8 wheel_now = 0;
    wheel_vaule = 0;

    if (!gpio_read(PIN_WHEEL_1)) //left
    {
        wheel_now |= 0x01;
    }
    if (!gpio_read(PIN_WHEEL_2)) //left
    {
        wheel_now |= 0x02;
    }
    if (wheel_now != wheel_pre)
    {
        wheel_pre = wheel_now;
        ret = WHEEL_DATA_EVENT_AAA;
        wheel_status = ((wheel_status << 2) & 0x3F) + wheel_now;
        if ((wheel_status == 0x07) || (wheel_status == 0x38))
        {
            wheel_vaule++;
        }
        else if ((wheel_status == 0x0b) || (wheel_status == 0x34))
        {
            wheel_vaule--;

        }

    }
    return ret;
}
#endif
_attribute_ram_code_ u8 wheel_get_value(u32 wheel_prepare_tick)
{
    u8 ret = 0;

    s8 wheel_now = 0;
#if PM_DEEPSLEEP_RETENTION_ENABLE

    ret = wheel_get_value_1();
#endif
    wheel_now = mouse_wheel_process(wheel_prepare_tick);

#if PM_DEEPSLEEP_RETENTION_ENABLE
    if (wheel_now == 0)
    {
        wheel_now = wheel_vaule;
    }
#endif

    if (user_cfg.wheel_direct != U8_MAX)
    {
        wheel_now = -wheel_now;
    }



    ms_data.wheel = wheel_now;
    if (wheel_now != 0)
    {
        ret = WHEEL_DATA_EVENT_AAA;
    }






    //wheel_set_wakeup_level_suspend(1);
    return ret;
}





#endif


void hw_init()
{



#if WHEEL_FUN_ENABLE_AAA

    wheel_init_hw();
#endif

#if BUTTON_FUN_ENABLE_AAA
    btn_init_hw();
#endif
#if BLT_APP_LED_ENABLE
    led_hw_init();
#endif
#if SENSOR_FUN_ENABLE_AAA

    OPTSensor_Init(1);
    if (!deepRetWakeUp)
    {
#if DPI_SAVE_FLASH
        if (fun_mode == RF_1M_BLE_MODE)
        {
            sensor_dpi_set(flash_dpi_info.bt_dpi);
        }
        else
        {
            sensor_dpi_set(flash_dpi_info.d24g_dpi);
        }
#else
        sensor_dpi_set(flash_dpi_info.bt_dpi);
#endif
    }

    output_dev_info.sensor_type = sensor_type;
    output_dev_info.sensor_pd1 = product_id1;
    output_dev_info.sensor_pd2 = product_id2;
    output_dev_info.sensor_pd3 = product_id3;
#if TEST_MCU_CURRENT_DEBUG
    OPTSensor_Shutdown();
#endif


#endif


}


u8 push_data_fifo_aaa(u8 *buf, u8 data_type, u8 len)
{
#if 0
    if ((tx_fifo_aaa.wptr - tx_fifo_aaa.rptr) >= TX_FIFO_NUM_AAA)
    {
        return 0;
    }

    TX_PACKET_AAA *p = (TX_PACKET_AAA *)tx_fifo_aaa.fifo[tx_fifo_aaa.wptr & (TX_FIFO_NUM_AAA - 1)];
    p->type = data_type;
    p->len = len;

    memcpy(p->buf, buf, len);

    tx_fifo_aaa.wptr++;
    return 1;
#else
    TX_PACKET_AAA *p = (TX_PACKET_AAA *)tx_fifo_aaa.fifo[tx_fifo_aaa.wptr & (TX_FIFO_NUM_AAA - 1)];
    p->type = data_type;
    p->len = len;
    memcpy(p->buf, buf, len);
    tx_fifo_aaa.wptr++;
    int fifo_use = (tx_fifo_aaa.wptr - tx_fifo_aaa.rptr) & (TX_FIFO_NUM_AAA * 2 - 1);
    if (fifo_use > TX_FIFO_NUM_AAA)
    {
        tx_fifo_aaa.rptr++;
    }
    return 1;
#endif
}
void push_report_fifo()
{

    if (has_new_report_aaa & HAS_MOUSE_REPORT)
    {

        // if (combination_flag)
        {

            // memset(&ms_data.btn, 0, sizeof(mouse_data_t));
        }

        // if (fun_mode == RF_1M_BLE_MODE)
        {
            if (push_data_fifo_aaa(&ms_data.btn, HAS_MOUSE_REPORT, sizeof(mouse_data_t)))
            {
                has_new_report_aaa &= ~HAS_MOUSE_REPORT;
            }
        }
        // else
        {
            //  has_new_report_aaa &= ~HAS_MOUSE_REPORT;
        }

    }
}

void ble_notify_data_proc_aaa()
{
    u8 need_ms_notify = 0;
    mouse_data_t buf;
    if (check_fifo_has_data() || ms_data.x || ms_data.y || ms_data.wheel)
    {

        loop_cnt = 0;
        if (tx_fifo_aaa.wptr != tx_fifo_aaa.rptr)
        {
            buf.btn = tx_fifo_aaa.fifo[tx_fifo_aaa.rptr & (TX_FIFO_NUM_AAA - 1)][2];
        }
        else
        {
            buf.btn = ms_data.btn;
        }
        buf.x = ms_data.x;
        buf.y = ms_data.y;
        buf.wheel = ms_data.wheel;
        need_ms_notify = 1;
    }
	if(active_disconnect_reason)
	{
		 buf.btn =0;
		 need_ms_notify = 1;
		  bls_att_pushNotifyData(HID_MOUSE_REPORT_INPUT_DP_H, &buf.btn, sizeof(mouse_data_t));
		 bls_ll_terminateConnection(HCI_ERR_REMOTE_USER_TERM_CONN);
		 return;
    }
    u8 txFifoNumber = blc_ll_getTxFifoNumber();
    if (need_ms_notify)
    {
        if (txFifoNumber < RF_TX_FIFO_ALLOW_NUM)
        {
            u8 status = bls_att_pushNotifyData(HID_MOUSE_REPORT_INPUT_DP_H, &buf.btn, sizeof(mouse_data_t));
            if (status == BLE_SUCCESS)
            {

                if (tx_fifo_aaa.wptr != tx_fifo_aaa.rptr)
                {
                    tx_fifo_aaa.rptr++;
                }
                ms_data.wheel = 0;

            }
#if UART_PRINT_DEBUG_ENABLE
            else
            {
                my_printf_aaa("notify_fail_reason=%x\r\n", status);
            }
#endif
        }
#if UART_PRINT_DEBUG_ENABLE
        else
        {
            my_printf_aaa("txFifo small=%x\r\n", txFifoNumber);
        }
#endif
    }
#if BATT_CHECK_ENABLE
#if 1
    else if (need_batt_data_notify)
    {
        if (txFifoNumber < RF_TX_FIFO_ALLOW_NUM)
        {
            u8 status = bls_att_pushNotifyData(BATT_LEVEL_INPUT_DP_H, my_batVal, 1);
            if (status == BLE_SUCCESS)
            {
                need_batt_data_notify = 0;
            }
        }
    }
#endif
#endif

}
u8 check_fifo_has_data()
{
    return (tx_fifo_aaa.wptr != tx_fifo_aaa.rptr);
}
void clear_fifo()
{
    tx_fifo_aaa.wptr = 0;
    tx_fifo_aaa.rptr = 0;
}
u8 clear_press_key_aaa()
{
    u8 buf[sizeof(mouse_data_t)] = {0, 0, 0, 0};
    push_data_fifo_aaa(buf, HAS_MOUSE_REPORT, sizeof(mouse_data_t));
    return 1;
}


void switch_type_init()
{

 // Hardware related
#if 0
	switch_type=TWO_SPEED_SWITCH;
	return;
#else
	if(gpio_read(PIN_SWITCH_TYPE))//two speed switch
	{
		switch_type=TWO_SPEED_SWITCH;
		gpio_setup_up_down_resistor(PIN_SWITCH_TYPE,PM_PIN_UP_DOWN_FLOAT);
		return;
	}
	switch_type=THREE_SPEED_SWITCH; //three swhtich 
    if (IS_BLE_MODE_AAA)
    {
        flash_dev_info.mode = RF_1M_BLE_MODE;
    }
    else
    {
        flash_dev_info.mode = RF_2M_2P4G_MODE;
    }
    gpio_setup_up_down_resistor(PIN_MODE_SWITCH,PM_PIN_UP_DOWN_FLOAT);
#if 0//test switch is good
    gpio_set_output_en(PIN_BLE_LED, 1);
    while (1)
    {
        if (IS_BLE_MODE_AAA)
        {

            gpio_write(PIN_BLE_LED, LED_ON_AAA);
        }
    else
    {
            gpio_write(PIN_24G_LED, LED_ON_AAA);
    }
}
#endif
#endif
}


void mouse_xy_multiple()
{
#if MUTI_SENSOR_ENABLE
    s32 x = 0, y = 0;
    if (xy_multiple_flag == MULTIPIPE_1_DOT_5)
    {
        x = ms_data.x;
        y = ms_data.y;
        x = (x * 3) / 2;
        y = (y * 3) / 2;
        ms_data.x = x;
        ms_data.y = y;
    }
#endif
}

void mouse_task_when_rf()
{


#if SENSOR_FUN_ENABLE_AAA

    if (OPTSensor_motion_report(0))
    {
        has_new_key_event |= SENSOR_DATA_EVENT_AAA;

        mouse_xy_multiple();
        check_sensor_dircet(user_cfg.sensor_direct);
        adaptive_smoother();
    }
    else
    {
        ms_data.x = 0;
        ms_data.y = 0;
    }

#endif
#if TEST_DRAW_A_SQUARE

    has_new_key_event |= Draw_a_square_test();
#elif TEST_MCU_CURRENT_DEBUG
    if (ms_data.btn == (MS_BTN_LEFT | MS_BTN_RIGHT))
    {
        has_new_key_event |= Draw_a_square_test();
    }
#endif

}
u8  Draw_a_square_test()
{
    _attribute_data_retention_user static int x = 0;
    _attribute_data_retention_user static u8 flag = 0;
    int step = 4;

    x++;
    if (x >= 50)
    {
        x = 0;
        flag++;
        if (flag > 3)
        {
            flag = 0;
        }

    }
    if (flag == 0)
    {
        ms_data.x = step;
        ms_data.y = 0;
    }
    else if (flag == 1)
    {
        ms_data.x = 0;
        ms_data.y = step;
    }
    else if (flag == 2)
    {
        ms_data.x = -step;
        ms_data.y = 0;
    }
    else if (flag == 3)
    {
        ms_data.x = 0;
        ms_data.y = -step;
    }
    return SENSOR_DATA_EVENT_AAA;

}

void clear_pair_flag()
{
    pair_flag = 0;
    analog_write(USED_DEEP_ANA_REG1, ana_reg1_aaa & CLEAR_PAIR_ANA_FLAG);
}
void set_pair_flag()
{
    pair_flag = 1;
    analog_write(USED_DEEP_ANA_REG1, ana_reg1_aaa | PAIR_ANA_FLG);
}
void write_deep_ana0(u8 buf)
{
    deep_flag = buf;
    analog_write(DEEP_ANA_REG0, buf);
}
void user_reboot(u8 reason)
{
    write_deep_ana0(reason);
    start_reboot();

}
#if DOUBLE_CLICK_LEFT_FUN_ENABLE

void  double_click_left_24G_mode()
{

    if (double_click_left_tick == 0)
    {
        ms_buf.btn = MS_BTN_LEFT;
        double_click_left_tick = clock_time() | 1;
        has_double_click_cnt = 1;
    }
    if ((has_double_click_cnt == 1) && clock_time_exceed(double_click_left_tick, DOUBLE_CLICK_LEFT_INTERVAL))
    {
        has_double_click_cnt = 2;
        ms_buf.btn = 0;
        double_click_left_tick = clock_time() | 1;
    }
    else if ((has_double_click_cnt == 2) && clock_time_exceed(double_click_left_tick, DOUBLE_CLICK_LEFT_INTERVAL))
    {
        has_double_click_cnt = 3;
        ms_buf.btn = MS_BTN_LEFT;
        double_click_left_tick = clock_time() | 1;
    }
    else if ((has_double_click_cnt == 3) && clock_time_exceed(double_click_left_tick, DOUBLE_CLICK_LEFT_INTERVAL))
    {
        has_double_click_cnt = 4;
        ms_buf.btn = 0;
        double_click_left_tick = clock_time() | 1;
    }
    else if ((has_double_click_cnt == 4) && clock_time_exceed(double_click_left_tick, DOUBLE_CLICK_LEFT_INTERVAL))
    {
        double_click_left_tick = 0;
        ms_buf.btn = 0;
        has_double_click_left = 0;
    }
}
void  double_click_left_ble_mode()
{

    if (double_click_left_tick == 0)
    {
        ms_buf.btn = MS_BTN_LEFT;
        ms_buf.x = 0;
        ms_buf.y = 0;
        ms_buf.wheel = 0;
        double_click_left_tick = clock_time() | 1;
        has_double_click_cnt = 1;
        push_data_fifo_aaa(&ms_buf.btn, HAS_MOUSE_REPORT, sizeof(mouse_data_t));
    }
    if ((has_double_click_cnt == 1) && clock_time_exceed(double_click_left_tick, DOUBLE_CLICK_LEFT_INTERVAL))
    {
        has_double_click_cnt = 2;
        ms_buf.btn = 0;
        double_click_left_tick = clock_time() | 1;
        push_data_fifo_aaa(&ms_buf.btn, HAS_MOUSE_REPORT, sizeof(mouse_data_t));
    }
    else if ((has_double_click_cnt == 2) && clock_time_exceed(double_click_left_tick, DOUBLE_CLICK_LEFT_INTERVAL))
    {
        has_double_click_cnt = 3;
        ms_buf.btn = MS_BTN_LEFT;
        double_click_left_tick = clock_time() | 1;
        push_data_fifo_aaa(&ms_buf.btn, HAS_MOUSE_REPORT, sizeof(mouse_data_t));
    }
    else if ((has_double_click_cnt == 3) && clock_time_exceed(double_click_left_tick, DOUBLE_CLICK_LEFT_INTERVAL))
    {
        has_double_click_cnt = 4;
        ms_buf.btn = 0;
        double_click_left_tick = clock_time() | 1;
        push_data_fifo_aaa(&ms_buf.btn, HAS_MOUSE_REPORT, sizeof(mouse_data_t));
    }
    else if ((has_double_click_cnt == 4) && clock_time_exceed(double_click_left_tick, DOUBLE_CLICK_LEFT_INTERVAL))
    {
        double_click_left_tick = 0;
        ms_buf.btn = 0;
        has_double_click_left = 0;
    }
}
#endif


u8 get_ble_data_report_aaa()
{
    //combination_flag = 0;
    //	s8 buf[2]={0,0};

#if WHEEL_FUN_ENABLE_AAA

    u32 wheel_prepare_tick;
    wheel_prepare_tick = mouse_wheel_prepare_tick();


#endif
#if BUTTON_FUN_ENABLE_AAA

    has_new_key_event |= btn_get_value();
#endif


#if SENSOR_FUN_ENABLE_AAA


    if (OPTSensor_motion_report(0))
    {
        has_new_key_event |= SENSOR_DATA_EVENT_AAA;

        mouse_xy_multiple();

        check_sensor_dircet(user_cfg.sensor_direct);
        adaptive_smoother();
    }
    else
    {
        ms_data.x = 0;
        ms_data.y = 0;
    }

#endif
#if TEST_DRAW_A_SQUARE
    if ((blc_ll_getCurrentState() == BLS_LINK_STATE_CONN) && ((ble_status_aaa == T5S_CONNECTED_STATUS_AAA)))
    {
        has_new_key_event |= Draw_a_square_test();
    }
    //test rf data
#elif (TEST_MCU_CURRENT_DEBUG)
    if ((blc_ll_getCurrentState() == BLS_LINK_STATE_CONN) && ((ble_status_aaa == T5S_CONNECTED_STATUS_AAA)))
    {
        if (ms_data.btn == (MS_BTN_LEFT | MS_BTN_RIGHT))
        {
            has_new_key_event |= Draw_a_square_test();
        }
    }

#endif

#if WHEEL_FUN_ENABLE_AAA

    has_new_key_event |= wheel_get_value(wheel_prepare_tick);



    //sensor_set_wakeup_level_suspend();
#endif
    if (has_new_key_event & (NEW_KEY_EVENT_AAA))
    {
        has_new_report_aaa |= HAS_MOUSE_REPORT;

    }
#if DOUBLE_CLICK_LEFT_FUN_ENABLE

    if (has_double_click_left)
    {
        double_click_left_ble_mode();
    }
    else
#endif
    {
        push_report_fifo();
    }
    return has_new_key_event;

}

void get_24g_data_report_aaa()
{
#if WHEEL_FUN_ENABLE_AAA
    u32 wheel_prepare_tick;

    wheel_prepare_tick = mouse_wheel_prepare_tick();

#endif
    //combination_flag = 0;


#if BUTTON_FUN_ENABLE_AAA
    has_new_key_event |= btn_get_value();
#endif

#if WHEEL_FUN_ENABLE_AAA
    has_new_key_event |= wheel_get_value(wheel_prepare_tick);
#endif

#if 0
    if (has_new_key_event)
    {
        has_new_report_aaa |= HAS_MOUSE_REPORT;

    }
    push_report_fifo();
#endif

}

